#pragma once
#include <iostream>
#include <stdlib.h>
#include <vector>
#include <set>
#include "StructDataType.h"
class MeshLoader {
private:
	Node getMiddleNode(const Edge&);
	std::vector<double> getMiddleEdge(const Edge&);
	std::vector<double> getCoordinate(int);
protected:
	std::vector<Node> Nodes;
	std::vector<FiniteElement> element;
	std::vector<FiniteElement> boundelement;
public:

	virtual void loadMesh(const std::string&) = 0;
	virtual ~MeshLoader() = default;

	const std::vector<Node>& getNodes();
	const std::vector<FiniteElement>& getFiniteElement();
	const std::vector<FiniteElement>& getBoundElement();

	std::vector<int> getFiniteElementID(int, int, int);
	std::vector<int> getFiniteElementEdge(int, int);
	std::vector<int> getNodesId(int);

	std::vector<int> getFiniteElementIdSurface(int);
	std::vector<int> getFiniteElementIDVol(int);

	void printNode();

	void printFiniteElement();

	void insertNodeMid();

	std::vector<std::set<int>> createNeighborsVector();





	
};

