#pragma once
#include <iostream>
#include <vector>

struct Node {
	int NodeID;
	std::vector<double> coordinate;
	bool bundle;

	friend std::ostream& operator<<(std::ostream&, const Node&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<Node>&);
};

struct FiniteElement {
	int FiniteElementID;
	int GeometryAreaID;
	std::vector<int> NodeID;

	friend std::ostream& operator<<(std::ostream&, const FiniteElement&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<FiniteElement>&);
};

struct Edge {
	std::pair<int, int> edgeNodes;
	int midNode = -1;
	Edge() = default;
	Edge(int, int);
	void updMid(int);
	Edge& operator=(const Edge&);
	bool operator==(const Edge&) const;
	friend std::istream& operator>>(std::istream&, Edge&);
	friend std::ostream& operator<<(std::ostream&, Edge&);
};
